<template>
  <v-container>
    <v-row>
      <v-col cols="12">
        <profile v-if="exists" :profile="profile" />
        <profile-not-found v-else :user-id="this.auth.id" />
      </v-col>
      <v-col cols="12">
        <fund :wallet="wallet" />
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import Profile from '@/components/profile/Profile.vue';
import { Profile as ProfileEntity } from '@/domain/entity/profile/Profile';
import ProfileNotFound from '@/components/profile/ProfileNotFound.vue';
import { AuthInfoResponse } from '@/domain/response/auth/info/AuthInfoResponse';
import Fund from '@/components/fund/Fund.vue';
import { Wallet } from '@/domain/entity/wallet/Wallet';

@Component({
  components: {
    Profile,
    ProfileNotFound,
    Fund
  }
})
export default class ProfileView extends Vue {
  private get exists(): boolean {
    return this.$store.getters['profile/exists'];
  }

  private get profile(): ProfileEntity | null {
    return this.$store.getters['profile/get'];
  }

  private get wallet(): Wallet | null {
    return this.$store.getters['wallet/item'];
  }

  private get auth(): AuthInfoResponse | null {
    return this.$store.getters['auth/info'];
  }

  private async mounted(): Promise<void> {
    if (this.auth) {
      await Promise.all([
        this.$store.dispatch('profile/fetch', this.auth.id),
        this.$store.dispatch('wallet/fetch', this.auth.id)
      ]);
    }
  }
}
</script>

<style scoped></style>
